--- ConsoleKit-0.4.1/src/ck-manager.c.1	2010-09-06 17:41:32.942210394 +0800
+++ ConsoleKit-0.4.1/src/ck-manager.c	2010-09-06 17:41:56.671280731 +0800
@@ -2604,16 +2736,321 @@ ck_manager_get_sessions (CkManager  *man
         return TRUE;
 }
 
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.AddSeat string:Default
+*/
+gboolean
+ck_manager_add_seat (CkManager  *manager,
+                     const char *type,
+                     char      **sid,
+                     GError    **error)
+{
+        CkSeat    *seat;
+                
+        g_debug ("CkManager: Add seat '%s'.", *sid);
+        g_return_val_if_fail (CK_IS_MANAGER (manager), FALSE);
+
+        seat = add_new_seat (manager, NULL, CK_SEAT_KIND_DYNAMIC, type);
+
+        if (!ck_seat_get_id (seat, sid, error)) {
+                return FALSE;
+        }
+
+        return TRUE;
+}
+
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.AddSeatById \
+  objpath:/org/freedesktop/ConsoleKit/SeatTest \
+*/
+gboolean
+ck_manager_add_seat_by_id (CkManager  *manager,
+                           const char *type,
+                           const char *sid,
+                           GError    **error) 
+{
+        CkSeat    *seat;
+
+        g_return_val_if_fail (CK_IS_MANAGER (manager), FALSE);
+
+        seat = add_new_seat (manager, sid, CK_SEAT_KIND_DYNAMIC, type);
+
+        return !(seat == NULL);
+}
+
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.RemoveSeat \
+  obj:/org/freedesktop/ConsoleKit/Seat2
+*/
+gboolean
+ck_manager_remove_seat (CkManager             *manager,
+                        const char            *sid,
+                        DBusGMethodInvocation *context)
+{
+        CkSeat     *seat = NULL;
+        CkSeatKind kind;
+
+        g_debug ("CkManager: Remove seat '%s'.", sid);
+        g_return_val_if_fail (CK_IS_MANAGER (manager), FALSE);
+
+        seat = g_hash_table_lookup (manager->priv->seats, sid);
+
+        if (seat == NULL) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR,
+                                     CK_SEAT_ERROR_GENERAL,
+                                     _("Seat '%s' doesn't exist"),
+                                     sid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        ck_seat_get_kind (seat, &kind, NULL);
+
+        if (kind == CK_SEAT_KIND_STATIC) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR,
+                                     CK_SEAT_ERROR_GENERAL,
+                                     _("Seat '%s' is static and can't be removed"),
+                                     sid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        if (ck_seat_is_managed (seat)) {
+                ck_seat_request_removal (seat);
+        } else {
+                remove_seat (manager, seat);
+        }
+
+        return TRUE;
+}
+
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.AddSession \
+  objpath:/org/freedesktop/ConsoleKit/Seat2 \
+  string:"LoginWindow" \
+  dict:string:string:"vt","vt9","display",":123"
+*/
+gboolean
+ck_manager_add_session (CkManager             *manager,
+                        const char            *sid,
+                        const char            *type,
+                        const char            *display_type,
+                        GHashTable            *variables,
+                        DBusGMethodInvocation *context)
+{
+        CkSeat    *seat;
+        CkSession *session;
+        char      *ssid;
+
+        g_debug ("CkManager: Add session");
+        seat = g_hash_table_lookup (manager->priv->seats, sid);
+
+        if (seat == NULL) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR,
+                                     CK_SEAT_ERROR_GENERAL, 
+                                     _("Seat '%s' doesn't exist"),
+                                     sid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        ssid = generate_session_id (manager);
+
+        session = ck_session_new (ssid, type, display_type, variables);
+
+        if (session == NULL) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR, 
+                                     CK_SEAT_ERROR_GENERAL,
+                                     _("Session could not be added to seat '%s'"),
+                                     sid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        ck_session_set_seat_id (session, sid, NULL);
+        if (IS_STR_SET (type) && g_str_equal (type, "LoginWindow")) {
+                session_set_remove_on_close (session, FALSE, NULL);
+        } else {
+                session_set_remove_on_close (session, TRUE, NULL);
+        }
+
+        ck_seat_add_session (seat, session, NULL);
+
+        g_hash_table_insert (manager->priv->sessions,
+                             ssid,
+                             session);
+
+        dbus_g_method_return (context, ssid);
+        return TRUE;
+}
+
+/*
+  Example:
+  dbus-send --system --dest=org.freedesktop.ConsoleKit \
+  --type=method_call --print-reply --reply-timeout=2000 \
+  /org/freedesktop/ConsoleKit/Manager \
+  org.freedesktop.ConsoleKit.Manager.RemoveSession \
+  objpath:/org/freedesktop/ConsoleKit/Session2
+*/
+gboolean
+ck_manager_remove_session (CkManager             *manager,
+                           const char            *ssid,
+                           DBusGMethodInvocation *context)
+{
+        CkSession *session;
+        CkSeat *seat;
+        GError *error; 
+        char *sid;
+        gboolean is_open;
+
+        g_debug ("CkManager: Remove session.");
+        session = g_hash_table_lookup (manager->priv->sessions, ssid);
+
+        if (session == NULL) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR,
+                                     CK_SEAT_ERROR_GENERAL,
+                                     _("Session '%s' doesn't exist"),
+                                     ssid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        ck_session_get_seat_id (session, &sid, NULL);
+        seat = g_hash_table_lookup (manager->priv->seats, sid);
+        g_free (sid);
+
+        if (seat == NULL) {
+                g_warning ("Session '%s' is not associated with a seat", ssid);
+                g_hash_table_remove (manager->priv->sessions, ssid);
+                return TRUE;
+        }
+
+        error = NULL;
+
+        ck_session_is_open (session, &is_open, NULL);
+        session_set_remove_on_close (session, TRUE, NULL);
+
+        /* We'll let the seat manager close us when it's ready
+         */
+        if (ck_seat_is_managed (seat) && is_open) {
+                ck_seat_request_close_session (seat, session, NULL);
+                dbus_g_method_return (context);
+
+                return TRUE;
+        }
+
+        if (!ck_seat_remove_session (seat, session, &error)) {
+                if (error == NULL) {
+                        return TRUE;
+                }
+                
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+                return FALSE;
+        }
+        
+        g_hash_table_remove (manager->priv->sessions, ssid);
+        dbus_g_method_return (context);
+        return TRUE;
+}
+ 
+static void
+add_sessions_from_seat (CkManager *manager,
+                        CkSeat    *seat)
+{
+        GPtrArray *sessions;
+        int i;
+
+        g_debug ("CkManager: Add session from seat.");
+        ck_seat_get_sessions (seat, &sessions, NULL);
+
+        for (i = 0; i < sessions->len; i++) {
+                char *ssid;
+                CkSession *session; 
+
+                ssid = g_ptr_array_index (sessions, i);
+                session = ck_seat_get_session (seat, ssid);
+
+                g_hash_table_insert (manager->priv->sessions,
+                                     ssid,
+                                     session);
+        }
+
+        g_ptr_array_free (sessions, TRUE);
+}
+
 static void
 add_seat_for_file (CkManager  *manager,
                    const char *filename)
 {
         char   *sid;
+        char   *orig_sid;
         CkSeat *seat;
 
+        g_debug ("CkManager: Add seat for file.");
         sid = generate_seat_id (manager);
+        orig_sid = g_strdup (sid);
+        seat = ck_seat_new_from_file (&sid, filename);
+
+        if (seat == NULL) {
+                /* returns null if connection to bus fails */
+                g_free (sid);
+                g_free (orig_sid);
+                manager->priv->seat_serial--;
+                return;
+        }
+
+        if (!g_str_equal (orig_sid, sid)) {
+                manager->priv->seat_serial--;
+        }
+        g_free (orig_sid);
 
-        seat = ck_seat_new_from_file (sid, filename);
+        add_sessions_from_seat (manager, seat);
+
+        if (seat == NULL) {
+                return;
+        }
 
         if (seat == NULL) {
                 return;
@@ -2636,7 +3073,7 @@ add_seat_for_file (CkManager  *manager,
         ck_seat_run_programs (seat, NULL, NULL, "seat_added");
 
         g_debug ("Emitting seat-added: %s", sid);
-        g_signal_emit (manager, signals [SEAT_ADDED], 0, sid);
+        g_signal_emit (manager, signals [SEAT_ADDED], 0, sid, "Default");
 
         log_seat_added_event (manager, seat);
 }
@@ -2647,6 +3084,7 @@ load_seats_from_dir (CkManager *manager)
         GDir       *d;
         GError     *error;
         const char *file;
+        GQueue      seat_queue;
 
         error = NULL;
         d = g_dir_open (CK_SEAT_DIR,
@@ -2658,17 +3096,26 @@ load_seats_from_dir (CkManager *manager)
                 return FALSE;
         }
 
+        g_queue_init (&seat_queue);
         while ((file = g_dir_read_name (d)) != NULL) {
                 if (g_str_has_suffix (file, ".seat")) {
                         char *path;
                         path = g_build_filename (CK_SEAT_DIR, file, NULL);
-                        add_seat_for_file (manager, path);
-                        g_free (path);
+                        g_queue_push_tail (&seat_queue, path);
                 }
         }
-
         g_dir_close (d);
 
+        g_queue_sort (&seat_queue, (GCompareDataFunc) strverscmp, NULL);
+
+        while (!g_queue_is_empty (&seat_queue)) {
+                char *path;
+
+                path = g_queue_pop_head (&seat_queue);
+                add_seat_for_file (manager, path);
+                g_free (path);
+        }
+
         return TRUE;
 }
 
@@ -2704,8 +3151,6 @@ ck_manager_init (CkManager *manager)
                                                         (GDestroyNotify) g_object_unref);
 
         manager->priv->logger = ck_event_logger_new (LOG_FILE);
-
-        create_seats (manager);
 }
 
 static void
@@ -2750,7 +3195,48 @@ ck_manager_new (void)
                         g_object_unref (manager_object);
                         return NULL;
                 }
+
+                create_seats (CK_MANAGER (manager_object));
         }
 
         return CK_MANAGER (manager_object);
 }
+
+gboolean
+ck_manager_will_not_respawn (CkManager             *manager,
+                             const char            *ssid,
+                             DBusGMethodInvocation *context)
+{
+        GError *error; 
+        CkSeat *seat;
+        CkSession *session;
+        char *sid;
+
+        g_debug ("CkManager: Will not respawn: '%s'.", ssid);
+        session = g_hash_table_lookup (manager->priv->sessions, ssid);
+
+        if (session == NULL) {
+                GError *error;
+
+                error = g_error_new (CK_SEAT_ERROR,
+                                     CK_SEAT_ERROR_GENERAL,
+                                     _("Session '%s' doesn't exist"),
+                                     ssid);
+
+                dbus_g_method_return_error (context, error);
+                g_error_free (error);
+
+                return FALSE;
+        }
+
+        session_set_remove_on_close (session, FALSE, NULL);
+        ck_session_get_seat_id (session, &sid, NULL);
+        seat = g_hash_table_lookup (manager->priv->seats, sid);
+        g_free (sid);
+
+        ck_seat_no_respawn (seat, session, &error);
+
+        dbus_g_method_return (context);
+        return TRUE;
+}
+
diff --git a/src/ck-manager.h b/src/ck-manager.h
index 4bd56e8..4304e71 100644
--- a/src/ck-manager.h
+++ b/src/ck-manager.h
@@ -49,7 +49,8 @@ typedef struct
         GObjectClass   parent_class;
 
         void          (* seat_added)               (CkManager  *manager,
-                                                    const char *sid);
+                                                    const char *sid,
+                                                    const char *type);
         void          (* seat_removed)             (CkManager  *manager,
                                                     const char *sid);
         void          (* system_idle_hint_changed) (CkManager  *manager,
@@ -96,6 +97,9 @@ gboolean            ck_manager_get_sessi
 gboolean            ck_manager_get_seats                      (CkManager             *manager,
                                                                GPtrArray            **seats,
                                                                GError               **error);
+gboolean            ck_manager_get_unmanaged_seats            (CkManager             *manager,
+                                                               GPtrArray            **seats,
+                                                               GError               **error);
 gboolean            ck_manager_close_session                  (CkManager             *manager,
                                                                const char            *cookie,
                                                                DBusGMethodInvocation *context);
@@ -128,6 +132,31 @@ gboolean            ck_manager_open_sess
                                                                const GPtrArray       *parameters,
                                                                DBusGMethodInvocation *context);
 
+gboolean            ck_manager_add_seat                       (CkManager             *manager,
+                                                               const char            *type,
+                                                               char                 **sid,
+                                                               GError               **error);
+gboolean            ck_manager_add_seat_by_id                 (CkManager             *manager,
+                                                               const char            *type,
+                                                               const char            *sid,
+                                                               GError               **error);
+gboolean            ck_manager_remove_seat                    (CkManager             *manager,
+                                                               const char            *sid,
+                                                               DBusGMethodInvocation *context);
+
+gboolean            ck_manager_add_session                    (CkManager             *manager,
+                                                               const char            *sid,
+                                                               const char            *type,
+                                                               const char            *display_type,
+                                                               GHashTable            *parameters,
+                                                               DBusGMethodInvocation *context);
+gboolean            ck_manager_remove_session                  (CkManager             *manager,
+                                                                const char            *ssid,
+                                                                DBusGMethodInvocation *context);
+gboolean            ck_manager_will_not_respawn               (CkManager             *manager,
+                                                               const char            *cookie,
+                                                               DBusGMethodInvocation *context);
+
 G_END_DECLS
 
 #endif /* __CK_MANAGER_H */
diff --git a/src/ck-marshal.list b/src/ck-marshal.list
index 7f60efc..f8029a6 100644
--- a/src/ck-marshal.list
+++ b/src/ck-marshal.list
@@ -1,3 +1,6 @@
 VOID:UINT,STRING
 BOOLEAN:POINTER
 VOID:OBJECT,OBJECT
+VOID:STRING,STRING
+VOID:STRING,BOOLEAN,STRING,POINTER,STRING,POINTER
+VOID:STRING,STRING,STRING,POINTER,STRING,POINTER
